# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xdnsarecord`](#dsc_xdnsarecord): The DSC xDnsARecord resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsrecord`](#dsc_xdnsrecord): The DSC xDnsRecord resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsserveradzone`](#dsc_xdnsserveradzone): The DSC xDnsServerADZone resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsserverforwarder`](#dsc_xdnsserverforwarder): The DSC xDnsServerForwarder resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsserverprimaryzone`](#dsc_xdnsserverprimaryzone): The DSC xDnsServerPrimaryZone resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsserversecondaryzone`](#dsc_xdnsserversecondaryzone): The DSC xDnsServerSecondaryZone resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsserversetting`](#dsc_xdnsserversetting): The DSC xDnsServerSetting resource type. Automatically generated from version 1.10.0.0
* [`dsc_xdnsserverzonetransfer`](#dsc_xdnsserverzonetransfer): The DSC xDnsServerZoneTransfer resource type. Automatically generated from version 1.10.0.0

## Resource types

### `dsc_xdnsarecord`

The DSC xDnsARecord resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsarecord` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this DNS resource record be present or absent

##### `dsc_target`

Data type: `String`

 

#### Parameters

The following parameters are available in the `dsc_xdnsarecord` type.

##### `dsc_name`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_zone`

namevar

Data type: `String`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsrecord`

The DSC xDnsRecord resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsrecord` type.

##### `dsc_dnsserver`

Data type: `Optional[String]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this DNS resource record be present or absent

##### `dsc_type`

Data type: `Enum['ARecord', 'CName']`

 

#### Parameters

The following parameters are available in the `dsc_xdnsrecord` type.

##### `dsc_name`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_target`

namevar

Data type: `String`

 

##### `dsc_zone`

namevar

Data type: `String`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsserveradzone`

The DSC xDnsServerADZone resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsserveradzone` type.

##### `dsc_computername`

Data type: `Optional[String]`

DNS Server name

##### `dsc_directorypartitionname`

Data type: `Optional[String]`

Directory partition name

##### `dsc_dynamicupdate`

Data type: `Optional[Enum['None', 'NonsecureAndSecure', 'Secure']]`

Dynamic zone update option

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DNS zone should be available or removed

##### `dsc_replicationscope`

Data type: `Enum['Custom', 'Domain', 'Forest', 'Legacy']`

Replication scope option

#### Parameters

The following parameters are available in the `dsc_xdnsserveradzone` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential used to set zone

##### `dsc_name`

namevar

Data type: `String`

DNS Server zone name

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsserverforwarder`

The DSC xDnsServerForwarder resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsserverforwarder` type.

##### `dsc_ipaddresses`

Data type: `Optional[Array[String]]`

 

#### Parameters

The following parameters are available in the `dsc_xdnsserverforwarder` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsserverprimaryzone`

The DSC xDnsServerPrimaryZone resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsserverprimaryzone` type.

##### `dsc_dynamicupdate`

Data type: `Optional[Enum['None', 'NonsecureAndSecure']]`

Dynamic zone update option

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DNS zone should be available or removed

##### `dsc_zonefile`

Data type: `Optional[String]`

DNS Server primary zone file

#### Parameters

The following parameters are available in the `dsc_xdnsserverprimaryzone` type.

##### `dsc_name`

namevar

Data type: `String`

DNS Server primary zone name

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsserversecondaryzone`

The DSC xDnsServerSecondaryZone resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsserversecondaryzone` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should this resource be present or absent

##### `dsc_masterservers`

Data type: `Array[String]`

IP address or DNS name of the secondary DNS servers

##### `dsc_type`

Data type: `Optional[String]`

Type of the DNS server zone

#### Parameters

The following parameters are available in the `dsc_xdnsserversecondaryzone` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the secondary zone

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsserversetting`

The DSC xDnsServerSetting resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsserversetting` type.

##### `dsc_addressanswerlimit`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum number of host records returned in response to an address request. Values between 5 and 28 are valid.

##### `dsc_allowupdate`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether the DNS Server accepts dynamic update requests.

##### `dsc_autocacheupdate`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server attempts to update its cache entries using data from root servers.

##### `dsc_autoconfigfilezones`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates which standard primary zones that are authoritative for the name of the DNS Server must be updated when the name server changes.

##### `dsc_bindsecondaries`

Data type: `Optional[Boolean]`

Determines the AXFR message format when sending to non-Microsoft DNS Server secondaries

##### `dsc_bootmethod`

Data type: `Optional[Integer[0, 4294967295]]`

Initialization method for the DNS Server.

##### `dsc_defaultagingstate`

Data type: `Optional[Boolean]`

Default ScavengingInterval value set for all Active Directory-integrated zones created on this DNS Server.

##### `dsc_defaultnorefreshinterval`

Data type: `Optional[Integer[0, 4294967295]]`

No-refresh interval, in hours, set for all Active Directory-integrated zones created on this DNS Server.

##### `dsc_defaultrefreshinterval`

Data type: `Optional[Integer[0, 4294967295]]`

Refresh interval, in hours, set for all Active Directory-integrated zones created on this DNS Server.

##### `dsc_disableautoreversezones`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server automatically creates standard reverse look up zones.

##### `dsc_disjointnets`

Data type: `Optional[Boolean]`

Indicates whether the default port binding for a socket used to send queries to remote DNS Servers can be overridden.

##### `dsc_dsavailable`

Data type: `Optional[Boolean]`

Indicates whether there is an available DS on the DNS Server.

##### `dsc_dspollinginterval`

Data type: `Optional[Integer[0, 4294967295]]`

Interval, in seconds, to poll the DS-integrated zones.

##### `dsc_dstombstoneinterval`

Data type: `Optional[Integer[0, 4294967295]]`

Lifetime of tombstoned records in Directory Service integrated zones, expressed in seconds.

##### `dsc_ednscachetimeout`

Data type: `Optional[Integer[0, 4294967295]]`

Lifetime, in seconds, of the cached information describing the EDNS version supported by other DNS Servers.

##### `dsc_enabledirectorypartitions`

Data type: `Optional[Boolean]`

Specifies whether support for application directory partitions is enabled on the DNS Server.

##### `dsc_enablednssec`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether the DNS Server includes DNSSEC-specific RRs, KEY, SIG, and NXT in a response.

##### `dsc_enableednsprobes`

Data type: `Optional[Boolean]`

Specifies the behavior of the DNS Server. When TRUE, the DNS Server always responds with OPT resource records according to RFC 2671, unless the remote server has indicated it does not support EDNS in a prior exchange. If FALSE, the DNS Server responds to queries with OPTs only if OPTs are sent in the original query.

##### `dsc_eventloglevel`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates which events the DNS Server records in the Event Viewer system log.

##### `dsc_forwarddelegations`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether queries to delegated sub-zones are forwarded.

##### `dsc_forwarders`

Data type: `Optional[Array[String]]`

Enumerates the list of IP addresses of Forwarders to which the DNS Server forwards queries.

##### `dsc_forwardingtimeout`

Data type: `Optional[Integer[0, 4294967295]]`

Time, in seconds, a DNS Server forwarding a query will wait for resolution from the forwarder before attempting to resolve the query itself.

##### `dsc_isslave`

Data type: `Optional[Boolean]`

TRUE if the DNS server does not use recursion when name-resolution through forwarders fails.

##### `dsc_listenaddresses`

Data type: `Optional[Array[String]]`

Enumerates the list of IP addresses on which the DNS Server can receive queries.

##### `dsc_localnetpriority`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server gives priority to the local net address when returning A records.

##### `dsc_logfilemaxsize`

Data type: `Optional[Integer[0, 4294967295]]`

Size of the DNS Server debug log, in bytes.

##### `dsc_logfilepath`

Data type: `Optional[String]`

File name and path for the DNS Server debug log.

##### `dsc_logipfilterlist`

Data type: `Optional[Array[String]]`

List of IP addresses used to filter DNS events written to the debug log.

##### `dsc_loglevel`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates which policies are activated in the Event Viewer system log.

##### `dsc_loosewildcarding`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server performs loose wildcarding.

##### `dsc_maxcachettl`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum time, in seconds, the record of a recursive name query may remain in the DNS Server cache.

##### `dsc_maxnegativecachettl`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum time, in seconds, a name error result from a recursive query may remain in the DNS Server cache.

##### `dsc_namecheckflag`

Data type: `Optional[Integer[0, 4294967295]]`

Indicates the set of eligible characters to be used in DNS names.

##### `dsc_norecursion`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server performs recursive look ups. TRUE indicates recursive look ups are not performed.

##### `dsc_recursionretry`

Data type: `Optional[Integer[0, 4294967295]]`

Elapsed seconds before retrying a recursive look up.

##### `dsc_recursiontimeout`

Data type: `Optional[Integer[0, 4294967295]]`

Elapsed seconds before the DNS Server gives up recursive query.

##### `dsc_roundrobin`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server round robins multiple A records.

##### `dsc_rpcprotocol`

Data type: `Optional[Integer[-32768, 32767]]`

RPC protocol or protocols over which administrative RPC runs.

##### `dsc_scavenginginterval`

Data type: `Optional[Integer[0, 4294967295]]`

Interval, in hours, between two consecutive scavenging operations performed by the DNS Server.

##### `dsc_secureresponses`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server exclusively saves records of names in the same subtree as the server that provided them.

##### `dsc_sendport`

Data type: `Optional[Integer[0, 4294967295]]`

Port on which the DNS Server sends UDP queries to other servers.

##### `dsc_strictfileparsing`

Data type: `Optional[Boolean]`

Indicates whether the DNS Server parses zone files strictly.

##### `dsc_updateoptions`

Data type: `Optional[Integer[0, 4294967295]]`

Restricts the type of records that can be dynamically updated on the server, used in addition to the AllowUpdate settings on Server and Zone objects.

##### `dsc_writeauthorityns`

Data type: `Optional[Boolean]`

Specifies whether the DNS Server writes NS and SOA records to the authority section on successful response.

##### `dsc_xfrconnecttimeout`

Data type: `Optional[Integer[0, 4294967295]]`

Time, in seconds, the DNS Server waits for a successful TCP connection to a remote server when attempting a zone transfer.

#### Parameters

The following parameters are available in the `dsc_xdnsserversetting` type.

##### `dsc_name`

namevar

Data type: `String`

Key for the resource.  It doesn't matter what it is as long as it's unique within the configuration.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdnsserverzonetransfer`

The DSC xDnsServerZoneTransfer resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xdnsserverzonetransfer` type.

##### `dsc_secondaryserver`

Data type: `Optional[Array[String]]`

IP address or DNS name of DNS servers where zone information can be transfered

##### `dsc_type`

Data type: `Enum['None', 'Any', 'Named', 'Specific']`

Type of transfer allowed

#### Parameters

The following parameters are available in the `dsc_xdnsserverzonetransfer` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the DNS zone

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

